diff -ruN ../nakedmudv2.1.1/src/socket.c src/socket.c
--- ../nakedmudv2.1.1/src/socket.c	Sun May  8 15:04:58 2005
+++ src/socket.c	Thu May 12 17:08:52 2005
@@ -11,6 +11,7 @@
 /* including main header file */
 #include "mud.h"
 #include "character.h"
+#include "account.h"
 #include "save.h"
 #include "utils.h"
 #include "socket.h"
@@ -19,9 +20,9 @@
 
 //
 // Here it is... the big ol' datastructure for sockets. Yum.
-//
 struct socket_data {
   CHAR_DATA     * player;
+  ACCOUNT_DATA  * account;
   char          * hostname;
   char            inbuf[MAX_INPUT_LEN];
   char            outbuf[MAX_OUTPUT];
@@ -38,7 +39,6 @@
   int             tot_pages;     // the total number of pages the string has
   
   BUFFER        * text_editor;   // where we do our actual work
-  char         ** text_pointer;  // where the work will go to
 
   LIST          * input_handlers;// a stack of our input handlers and prompts
 
@@ -53,13 +53,21 @@
 //
 // contains an input handler and the socket prompt in one structure, so they
 // can be stored together in the socket_data
-//
 typedef struct input_handler_data {
   void (* handler)(SOCKET_DATA *, char *);
   void (*  prompt)(SOCKET_DATA *);
 } IH_PAIR;
 
 
+//
+// required for looking up a socket's IP in a new thread
+typedef struct lookup_data {
+  SOCKET_DATA    * dsock;   // the socket we wish to do a hostlookup on
+  char           * buf;     // the buffer it should be stored in
+} LOOKUP_DATA;
+
+
+
 /* global variables */
 fd_set        fSet;             /* the socket list for polling       */
 fd_set        rFd;
@@ -179,7 +187,7 @@
 
   /* send the greeting */
   text_to_buffer(sock_new, greeting);
-  text_to_buffer(sock_new, "Who wants to get naked? ");
+  text_to_buffer(sock_new, "What is your account (not character) name? ");
 
   /* everything went as it was supposed to */
   return TRUE;
@@ -212,7 +220,6 @@
   //  listRemove(socket_list, dsock);
   //
 
-
   // we have a character, and it's one that's
   // not in the process of being created
   if (dsock->player && charGetUID(dsock->player) != NOBODY) {
@@ -227,6 +234,9 @@
     charSetSocket(dsock->player, NULL);
     extract_mobile(dsock->player);
   }
+  
+  if(dsock->account)
+    deleteAccount(dsock->account);
 
   /* set the closed state */
   dsock->closed = TRUE;
@@ -671,7 +681,8 @@
 
 bool flush_output(SOCKET_DATA *dsock)
 {
-  void (* prompt_func)(SOCKET_DATA *) = ((IH_PAIR *)listGet(dsock->input_handlers, 0))->prompt;
+  IH_PAIR *pair = listGet(dsock->input_handlers, 0);
+  void (* prompt_func)(SOCKET_DATA *) = (pair ? pair->prompt : NULL);
 
   // quit if we have no output and don't need/can't have a prompt
   if(dsock->top_output <= 0 && (!dsock->bust_prompt || !prompt_func))
@@ -730,12 +741,9 @@
   socketPushInputHandler(sock_new, handle_new_connections, NULL);
   sock_new->control        = sock;
   sock_new->lookup_status  = TSTATE_LOOKUP;
-  sock_new->player         = NULL;
   sock_new->top_output     = 0;
 
   sock_new->text_editor    = newBuffer(MAX_BUFFER);
-  sock_new->text_pointer   = NULL;
-  //  sock_new->in_text_edit   = FALSE;
 }
 
 
@@ -807,12 +815,13 @@
 
 
 /* Recover from a copyover - load players */
-void copyover_recover()
-{     
-  CHAR_DATA *dMob;
-  SOCKET_DATA *dsock;
+void copyover_recover() {     
+  CHAR_DATA    *dMob;
+  ACCOUNT_DATA *account;
+  SOCKET_DATA  *dsock;
   FILE *fp;
-  char name [100];
+  char acct[100];
+  char name[100];
   char host[MAX_BUFFER];
   int desc;
       
@@ -827,7 +836,7 @@
   unlink(COPYOVER_FILE);
 
   for (;;) {  
-    fscanf(fp, "%d %s %s\n", &desc, name, host);
+    fscanf(fp, "%d %s %s %s\n", &desc, acct, name, host);
     if (desc == -1)
       break;
 
@@ -841,36 +850,53 @@
     dsock->hostname = strdup(host);
     listPut(socket_list, dsock);
 
-    /* load player data */
-    if ((dMob = load_player(name)) != NULL)
-    {
-      /* attach to socket */
+    // load account data
+    if((account = load_account(acct)) != NULL)
+      socketSetAccount(dsock, account);
+    // no luck!
+    else {
+      printf("Account load failed.\r\n");
+      close_socket(dsock, FALSE);
+      continue;
+    }
+
+    // load player data
+    if ((dMob = load_player(name)) != NULL) {
+      // attach to socket
       charSetSocket(dMob, dsock);
       socketSetChar(dsock, dMob);
 
       // try putting the character into the game
       // close the socket if we fail.
-      try_enter_game(dMob);
+      if(!try_enter_game(dMob)) {
+	printf("Enter game failed.\r\n");
+	// do not bother extracting, since we haven't entered the game yet
+	deleteChar(socketGetChar(dsock));
+	socketSetChar(dsock, NULL);
+	close_socket(dsock, FALSE);
+	continue;
+      }
     }
-    else /* ah bugger */
-    {
+    // no luck
+    else {
+      printf("Player load failed.\r\n");
       close_socket(dsock, FALSE);
       continue;
     }
    
-    /* Write something, and check if it goes error-free */
-    if (!text_to_socket(dsock, "\n\r <*>  And before you know it, everything has changed  <*>\n\r"))
-    { 
+    // Write something, and check if it goes error-free
+    if (!text_to_socket(dsock, "\n\r <*>  And before you know it, everything has changed  <*>\n\r")) { 
       close_socket(dsock, FALSE);
       continue;
     }
   
-    /* make sure the socket can be used */
+    // make sure the socket can be used
     dsock->bust_prompt    =  TRUE;
     dsock->lookup_status  =  TSTATE_DONE;
-    socketReplaceInputHandler(dsock, handle_cmd_input, show_prompt);
+    socketReplaceInputHandler(dsock, account_handle_menu, account_menu);
+    socketPushInputHandler(dsock, handle_cmd_input, show_prompt);
 
-    /* negotiate compression */
+    // negotiate compression
     text_to_buffer(dsock, (char *) compress_will2);
     text_to_buffer(dsock, (char *) compress_will);
   }
@@ -886,12 +912,10 @@
   SOCKET_DATA     *sock = NULL; 
 
   ITERATE_LIST(sock, sock_i) {
-    /*
-     * Close sockects we are unable to read from, or if we have no handler
-     * to take in input
-     */
+    // Close sockects we are unable to read from, or if we have no handler
+    // to take in input
     if ((FD_ISSET(sock->control, &rFd) && !read_from_socket(sock)) ||
-	socketGetInputHandler(sock) == NULL) {
+	listSize(sock->input_handlers) == 0) {
       close_socket(sock, FALSE);
       continue;
     }
@@ -907,13 +931,13 @@
     }
     
     /* if the player quits or get's disconnected */
-    if(sock->closed) continue;
+    if(sock->closed)
+      continue;
     
     /* Send all new data to the socket and close it if any errors occour */
     if (!flush_output(sock))
       close_socket(sock, FALSE);
-  }
-  deleteListIterator(sock_i);
+  } deleteListIterator(sock_i);
 }
 
 
@@ -999,67 +1023,62 @@
     dsock->curr_page = dsock->tot_pages;
     text_to_buffer(dsock, "There is no more text in your page buffer.\r\n");
   }
-  /*
-  if(dsock->curr_page >= dsock->tot_pages)
-    delete_page(dsock);
-  */
 }
 
 void do_copyover(CHAR_DATA *ch) {
-
+  LIST_ITERATOR *sock_i = newListIterator(socket_list);
+  SOCKET_DATA     *sock = NULL;
   FILE *fp;
-  SOCKET_DATA *dsock;
   char buf[100];
   char control_buf[20];
   char port_buf[20];
-  LIST_ITERATOR *sock_i = newListIterator(socket_list);
 
-  if ((fp = fopen(COPYOVER_FILE, "w+")) == NULL)
-  {
+  if ((fp = fopen(COPYOVER_FILE, "w+")) == NULL) {
     text_to_char(ch, "Copyover file not writeable, aborted.\n\r");
     return;
   }
 
   sprintf(buf, "\n\r <*>            The world starts spinning             <*>\n\r");
 
-  /* For each playing descriptor, save its state */
-  ITERATE_LIST(dsock, sock_i) {
-    compressEnd(dsock, dsock->compressing, FALSE);
-    if (!socketGetChar(dsock) || !charGetRoom(socketGetChar(dsock))) {
-      //(dsock->state != STATE_PLAYING) {
-      text_to_socket(dsock, "\r\nSorry, we are rebooting. Come back in a few minutes.\r\n");
-      close_socket(dsock, FALSE);
+  // For each playing descriptor, save its character and account
+  ITERATE_LIST(sock, sock_i) {
+    compressEnd(sock, sock->compressing, FALSE);
+    // kick off anyone who hasn't yet logged in a character
+    if (!socketGetChar(sock) || !charGetRoom(socketGetChar(sock))) {
+      text_to_socket(sock, "\r\nSorry, we are rebooting. Come back in a few minutes.\r\n");
+      close_socket(sock, FALSE);
     }
+    // save account and player info to file
     else {
-      fprintf(fp, "%d %s %s\n",
-	      dsock->control, charGetName(dsock->player), dsock->hostname);
-      /* save the player */
-      save_player(dsock->player);
-      text_to_socket(dsock, buf);
+      fprintf(fp, "%d %s %s %s\n",
+	      sock->control, accountGetName(sock->account), 
+	      charGetName(sock->player), sock->hostname);
+      // save the player
+      save_player(sock->player);
+      save_account(sock->account);
+      text_to_socket(sock, buf);
     }
   } deleteListIterator(sock_i);
   
   fprintf (fp, "-1\n");
   fclose (fp);
 
-
-  /* close any pending sockets */
+  // close any pending sockets
   recycle_sockets();
   
-  /* exec - descriptors are inherited */
+  // exec - descriptors are inherited
   sprintf(control_buf, "%d", control);
   sprintf(port_buf, "%d", mudport);
   execl(EXE_FILE, "NakedMud", "-copyover", control_buf, port_buf, NULL);
 
-  /* Failed - sucessful exec will not return */
+  // Failed - sucessful exec will not return
   text_to_char(ch, "Copyover FAILED!\n\r");
 }
 
 
+
 //*****************************************************************************
-//
 // get and set functions
-//
 //*****************************************************************************
 CHAR_DATA *socketGetChar     ( SOCKET_DATA *dsock) {
   return dsock->player;
@@ -1069,12 +1088,12 @@
   dsock->player = ch;
 }
 
-char **socketGetTextPointer   ( SOCKET_DATA *sock) {
-  return sock->text_pointer;
+ACCOUNT_DATA *socketGetAccount ( SOCKET_DATA *dsock) {
+  return dsock->account;
 }
 
-void socketSetTextPointer (SOCKET_DATA *sock, char **ptr) {
-  sock->text_pointer = ptr;
+void socketSetAccount (SOCKET_DATA *dsock, ACCOUNT_DATA *account) {
+  dsock->account = account;
 }
 
 BUFFER *socketGetTextEditor   ( SOCKET_DATA *sock) {
@@ -1103,7 +1122,10 @@
 }
 
 void (*socketGetInputHandler ( SOCKET_DATA *socket))(SOCKET_DATA *, char *) {
-  return ((IH_PAIR *)listGet(socket->input_handlers, 0))->handler;
+  if(listSize(socket->input_handlers) == 0)
+    return NULL;
+  IH_PAIR *pair = listGet(socket->input_handlers, 0);
+  return (pair ? pair->handler : NULL);
 }
 
 void socketShowPrompt( SOCKET_DATA *sock) {
diff -ruN ../nakedmudv2.1.1/src/socket.d src/socket.d
--- ../nakedmudv2.1.1/src/socket.d	Sun May  8 15:05:28 2005
+++ src/socket.d	Thu May 12 17:17:52 2005
@@ -1,3 +1,3 @@
 socket.d socket.o: socket.c wrapsock.h mud.h property_table.h list.h map.h \
-  hashtable.h set.h buffer.h bitvector.h character.h save.h utils.h \
-  socket.h auxiliary.h
+  hashtable.h set.h buffer.h bitvector.h character.h account.h save.h \
+  utils.h socket.h auxiliary.h
diff -ruN ../nakedmudv2.1.1/src/socket.h src/socket.h
--- ../nakedmudv2.1.1/src/socket.h	Sun May  8 15:04:45 2005
+++ src/socket.h	Thu May 12 17:08:52 2005
@@ -37,8 +37,11 @@
 //*****************************************************************************
 sh_int socketGetDNSLookupStatus( SOCKET_DATA *sock);
 
-CHAR_DATA *socketGetChar     ( SOCKET_DATA *dsock);
-void       socketSetChar     ( SOCKET_DATA *dsock, CHAR_DATA *ch);
+CHAR_DATA *socketGetChar      ( SOCKET_DATA *dsock);
+void       socketSetChar      ( SOCKET_DATA *dsock, CHAR_DATA *ch);
+
+ACCOUNT_DATA *socketGetAccount( SOCKET_DATA *dsock);
+void          socketSetAccount( SOCKET_DATA *dsock, ACCOUNT_DATA *account);
 
 void socketPushInputHandler   ( SOCKET_DATA *socket, 
 			        void handler(SOCKET_DATA *socket, char *input),
@@ -52,8 +55,6 @@
 void *socketGetAuxiliaryData  ( SOCKET_DATA *sock, const char *name);
 const char *socketGetHostname ( SOCKET_DATA *sock);
 BUFFER *socketGetTextEditor   ( SOCKET_DATA *sock);
-char **socketGetTextPointer   ( SOCKET_DATA *sock);
-void socketSetTextPointer     ( SOCKET_DATA *sock, char **ptr);
 
 void socketBustPrompt         ( SOCKET_DATA *sock);
 
diff -ruN ../nakedmudv2.1.1/src/storage.c src/storage.c
--- ../nakedmudv2.1.1/src/storage.c	Sun May  8 15:04:45 2005
+++ src/storage.c	Thu May 12 17:08:52 2005
@@ -89,8 +89,7 @@
 }
 
 STORAGE_DATA *new_storage_data(const char *key) {
-  STORAGE_DATA *data = malloc(sizeof(STORAGE_DATA));
-  bzero(data, sizeof(*data));
+  STORAGE_DATA *data = calloc(1, sizeof(STORAGE_DATA));
   data->key     = strdup(key);
   return data;
 }
@@ -119,6 +118,11 @@
   return data;
 }
 
+STORAGE_DATA    *new_data_bool(bool val, const char *key) {
+  char str_val[4]; sprintf(str_val, (val ? "yes" : "no"));
+  return new_data_string(str_val, key);
+}
+
 STORAGE_DATA    *new_data_int(int val, const char *key) {
   char str_val[20]; sprintf(str_val, "%d", val);
   return new_data_string(str_val, key);
@@ -570,6 +574,10 @@
   storage_put(set, new_data_double(val, key));
 }
 
+void store_bool(STORAGE_SET *set, const char *key, bool val) {
+  storage_put(set, new_data_bool(val, key));
+}
+
 void store_int(STORAGE_SET *set, const char *key, int val) {
   storage_put(set, new_data_int(val, key));
 }
@@ -602,6 +610,18 @@
   STORAGE_DATA *data = hashGet(set->entries, key);
   if(data) return data->str_val;
   else     return "";
+}
+
+bool read_bool(STORAGE_SET *set, const char *key) {
+  STORAGE_DATA *data = hashGet(set->entries, key);
+  if(data == NULL) 
+    return FALSE;
+  else if(!strcasecmp(data->str_val, "Yes"))
+    return TRUE;
+  else if(atoi(data->str_val) != 0)
+    return TRUE;
+  else
+    return FALSE;
 }
 
 double read_double(STORAGE_SET *set, const char *key) {
diff -ruN ../nakedmudv2.1.1/src/storage.h src/storage.h
--- ../nakedmudv2.1.1/src/storage.h	Sun May  8 15:04:45 2005
+++ src/storage.h	Thu May 12 17:08:52 2005
@@ -65,6 +65,7 @@
 void store_double(STORAGE_SET *set, const char *key, double val);
 void    store_int(STORAGE_SET *set, const char *key, int val);
 void   store_long(STORAGE_SET *set, const char *key, long val);
+void   store_bool(STORAGE_SET *set, const char *key, bool val);
 
 
 //
@@ -76,6 +77,7 @@
 double            read_double(STORAGE_SET *set, const char *key);
 int                  read_int(STORAGE_SET *set, const char *key);
 long                read_long(STORAGE_SET *set, const char *key);
+bool                read_bool(STORAGE_SET *set, const char *key);
 
 
 //
diff -ruN ../nakedmudv2.1.1/src/utils.c src/utils.c
--- ../nakedmudv2.1.1/src/utils.c	Sun May  8 15:04:45 2005
+++ src/utils.c	Thu May 12 17:08:52 2005
@@ -35,25 +35,6 @@
 
 
 
-/*
- * Check to see if a given name is
- * legal, returning FALSE if it
- * fails our high standards...
- */
-bool check_name(const char *name)
-{
-  int size, i;
-
-  if ((size = strlen(name)) < 3 || size > 12)
-    return FALSE;
-
-  for (i = 0 ;i < size; i++)
-    if (!isalpha(name[i])) return FALSE;
-
-  return TRUE;
-}
-
-
 void  add_extract_obj_func (void (* func)(OBJ_DATA *)) {
   listQueue(extract_obj_funcs, func);
 }
@@ -500,6 +481,20 @@
 }
 
 
+//
+// just a generic function for hashing a string. This could be 
+// sped up tremendously if it's performance becoming a problem.
+int string_hash(const char *key) {
+  const int BASE = 2;
+  int base = 1;
+  int hvalue = 0;
+  for (; *key; key++) {
+    base *= BASE;
+    hvalue += tolower(*key) * base;
+  }
+  return (hvalue < 0 ? hvalue * -1 : hvalue);
+}
+
 
 void format_string(char **string, int max_width, 
 		   unsigned int maxlen, bool indent) {
@@ -742,9 +737,12 @@
   // first, we check if the keywords have any non-spaces
   int i;
   bool nonspace_found = FALSE;
-  for(i = 0; keywords[i] != '\0'; i++)
-    if(!isspace(keywords[i]))
+  for(i = 0; keywords[i] != '\0'; i++) {
+    if(!isspace(keywords[i])) {
       nonspace_found = TRUE;
+      break;
+    }
+  }
 
   // we didn't find any non-spaces. Return NULL
   if(!nonspace_found)
@@ -1277,6 +1275,9 @@
   return ret_val;
 }
 
+void *identity_func(void *data) {
+  return data;
+}
 
 void show_prompt(SOCKET_DATA *socket) {
   text_to_buffer(socket, custom_prompt(socketGetChar(socket)));
@@ -1288,3 +1289,4 @@
   strcat(prompt, "\r\nprompt> ");    
   return prompt;
 }
+
diff -ruN ../nakedmudv2.1.1/src/utils.h src/utils.h
--- ../nakedmudv2.1.1/src/utils.h	Sun May  8 15:04:45 2005
+++ src/utils.h	Thu May 12 17:08:52 2005
@@ -11,11 +11,9 @@
 
 
 //*****************************************************************************
-//
 // Utilities for numbers
-//
 //*****************************************************************************
-#define MAX_INT               214743648
+#define MAX_INT               214743647
 #define PI                    3.14159265
 
 #define UMIN(a, b)	      ((a) < (b) ? (a) : (b))
@@ -45,9 +43,7 @@
 
 
 //*****************************************************************************
-//
 // Utilities for characters
-//
 //*****************************************************************************
 #define IS_ADMIN(ch)          ((charGetLevel(ch)) > LEVEL_PLAYER ? TRUE : FALSE)
 
@@ -70,7 +66,6 @@
 //
 // returns the target's name if the ch can see the target,
 // and returns SOMEONE/SOMETHING otherwise.
-//
 const char *see_char_as (CHAR_DATA *ch, CHAR_DATA *target);
 const char *see_obj_as  (CHAR_DATA *ch, OBJ_DATA  *target);
 
@@ -80,10 +75,10 @@
 void     show_prompt(SOCKET_DATA *socket);
 const char *custom_prompt (CHAR_DATA *ch);
 
+
+
 //*****************************************************************************
-//
 // Utilities for bit manipulations and bitvectors
-//
 //*****************************************************************************
 #define BITS_PER_BITVECTOR                   32
 
@@ -97,10 +92,9 @@
 void        print_bits(bitvector_t bits, const char **names, char *buf);
 
 
+
 //*****************************************************************************
-//
 // String utilities.
-//
 //*****************************************************************************
 #define CLEAR_SCREEN      "\033[H\033[J"
 #define AN(string)        (strchr("AEIOU", toupper(*string)) ? "an" : "a")
@@ -127,12 +121,12 @@
 			   int buflen, bool border);
 int next_space_in         (char *string);
 int next_letter_in        (const char *string, char marker);
+int string_hash           (const char *key);
+
 
 
 //*****************************************************************************
-//
 // utilities for game functioning
-//
 //*****************************************************************************
 void  extract_obj          ( OBJ_DATA *obj);
 void  extract_mobile       ( CHAR_DATA *ch );
@@ -142,11 +136,21 @@
 void  add_extract_mob_func ( void (* func)(CHAR_DATA *));
 
 char *get_time             ( void );
-bool  check_name           ( const char *name );
 void  communicate          ( CHAR_DATA *dMob, char *txt, int range );
 void  load_muddata         ( void );
 CHAR_DATA  *check_reconnect( const char *player );
 
+
+
+//*****************************************************************************
+// misc utils
+//*****************************************************************************
+
+//
+// a function that returns the argument passed into it
+void *identity_func(void *data);
+
+
 // iterate across all the elements in a list
 #define ITERATE_LIST(val, it) \
   for(val = listIteratorCurrent(it); val != NULL; val = listIteratorNext(it))
@@ -178,7 +182,6 @@
 // count how many objects are in the list, that meet our critereon.
 // If name is not NULL, we search by name. Otherwise, we search by vnum.
 // must_see TRUE, a looker must be supplied. Same thing goes for count_letters
-//
 int   count_objs   (CHAR_DATA *looker, LIST *list, const char *name, int vnum,
 		    bool must_see);
 int   count_chars  (CHAR_DATA *looker, LIST *list, const char *name, int vnum,
@@ -201,12 +204,10 @@
 // split a string into it's target and count number.
 //   e.g. all.cookie splits into cookie and all
 //        2.woman splits into woman and 2
-//
 void get_count(const char *buf, char *target, int *count);
 
 //
 // reverse of get_count
-//
 void print_count(char *buf, const char *target, int count);
 
 
@@ -223,7 +224,6 @@
 //       a man and a woman
 //       (5) a man
 //       a group of 5 men
-//
 char *print_list(LIST *list, void *descriptor, void *multi_descriptor);
 
 
@@ -237,7 +237,6 @@
 // vnum_getter is a pointer to a function that returns the thing's vnum for
 // displaying to players of builder level and above. vnum_getter can be NULL 
 // to display no vnums.
-//
 void show_list(CHAR_DATA *ch, LIST *list, void *descriptor, 
 	       void *multi_descriptor, void *vnum_getter);
 
@@ -246,13 +245,11 @@
 // Return a list of all items in the current list that do not have
 // people sitting on or at them. The returned list must be deleted
 // after use.
-//
 LIST *get_unused_items(CHAR_DATA *ch, LIST *list, bool invis_ok);
 
 
 //
 // The opposite of get_unused_items
-//
 LIST *get_used_items(CHAR_DATA *ch, LIST *list, bool invis_ok);
 
 
@@ -260,8 +257,6 @@
 // returns true if the character has an object with the
 // specified vnum in his inventory. Returns false otherwise.
 // useful fo checking keys
-//
 bool has_obj(CHAR_DATA *ch, int vnum);
-
 
 #endif // __UTILS_H
